#ifndef CHANNEL_H
#define CHANNEL_H

/* generic channel*/
typedef struct _channel_t
{
  int (*plain) (struct _channel_t *);
  int (*fileno) (struct _channel_t *);
  const char *(*remoteaddr) (struct _channel_t *);
  struct _channel_t *(*accept) (struct _channel_t *);
  int (*send) (struct _channel_t *, const char *, size_t);
  int (*sendfile) (struct _channel_t *, int fd, size_t);
  int (*receive) (struct _channel_t *, char **, size_t *);
  void (*close) (struct _channel_t *);
} channel_t;

int channel_is_plain (channel_t *);
int channel_get_fd (channel_t *);
const char *channel_get_remoteaddr (channel_t *);
channel_t *channel_accept (channel_t *);
int channel_send (channel_t *, const char *, size_t);
int channel_send_file (channel_t *, int, size_t);
int channel_receive (channel_t *, char **, size_t *);
void channel_delete (channel_t *);

#endif
